var BASE_URL = '';
var HEADERS = {};

module.exports.sync = function(method, model, options)
{
	var error;
	var payload = model.toJSON();
	
	http_request('GET', BASE_URL, payload, callback);

	if (error)
	{
		options.error(model, error, options);
		Ti.API.error(error);
		model.trigger('error');
	}

	function callback(error, response)
	{
		var res = response ? JSON.parse(response) : null;
		if (error)
		{
			// Calls the default Backbone error callback and invokes a custom callback if options.error was defined.
			var err = (res && res.error) || error;
			Ti.API.error('ERROR: ' + err);
			options.error(model, error, options);
			model.trigger('error');
		}
		else
		{
			// Calls the default Backbone success callback and invokes a custom callback if options.success was defined.
			options.success(res, response, options);
		}
	};
};

function http_request(method, url, payload, callback)
{
	if (Ti.Network.online)
	{
		var client = Ti.Network.createHTTPClient({
			onload: function(e)
			{
				if(callback) callback(null, this.responseText);
			},
			onerror: function(e)
			{
				if(callback) callback(e.error, this.responseText);
			},
			timeout : 30000
		});
	
		client.open(method, url);
		
		for(var header in HEADERS)
		{
			client.setRequestHeader(header, HEADERS[header]);
		}
		
		client.send(JSON.stringify(payload));
	}
};

module.exports.beforeModelCreate = function(config, name)
{
	config = config || {};
	BASE_URL = config.url || config.getUrl();
	HEADERS = config.headers || config.getHeaders();
	
	return config;
};

module.exports.afterModelCreate = function(Model, name)
{
	// Nothing to do
};